Index: framspy/evolalg/examples/standard.py
===================================================================
--- framspy/evolalg/examples/standard.py	(revision 1132)
+++ framspy/evolalg/examples/standard.py	(revision 1133)
@@ -4,29 +4,26 @@
 import numpy as np
 
-#TODO add new example: steadystate.py (analogous to standard.py) OR include steadysteate as a mode in this example or in niching_novelty.py
-#TODO extend both standard.py and steadystate.py to support >1 criteria (using DEAP's selNSGA2() and selSPEA2())
-#TODO add comments to all examples in this directory
-#TODO add to standard.py and steadystate.py evaluating each genotype in HOF N (configurable, default 10) times when the evolution ends instead of evaluating the last population as it is now in niching_novelty.py
-#TODO protect all examples against invalid genotypes (fill population until all genotypes are conrrectly evaluated). And maybe remove invalid.py if it overlaps with (is a subset of) other examples
-#TODO "debug" mode, displaying Step-based class names and their arguments so it is easy to see what happens during evolution
+# TODO add new example: steadystate.py (analogous to standard.py) OR include steadysteate as a mode in this example or in niching_novelty.py
+# TODO extend both standard.py and steadystate.py to support >1 criteria (using DEAP's selNSGA2() and selSPEA2())
+# TODO add comments to all examples in this directory
+# TODO add to standard.py and steadystate.py evaluating each genotype in HOF N (configurable, default 10) times when the evolution ends instead of evaluating the last population as it is now in niching_novelty.py
+# TODO "debug" mode, displaying Step-based class names and their arguments so it is easy to see what happens during evolution
 
-from evolalg.base.lambda_step import LambdaStep
+
+from FramsticksLib import FramsticksLib
+from evolalg.base.union_step import UnionStep
 from evolalg.experiment import Experiment
 from evolalg.fitness.fitness_step import FitnessStep
 from evolalg.mutation_cross.frams_cross_and_mutate import FramsCrossAndMutate
 from evolalg.population.frams_population import FramsPopulation
-from evolalg.repair.multistep import MultistepRepair
 from evolalg.repair.remove.field import FieldRemove
 from evolalg.selection.tournament import TournamentSelection
 from evolalg.statistics.halloffame_stats import HallOfFameStatistics
 from evolalg.statistics.statistics_deap import StatisticsDeap
-from evolalg.base.union_step import UnionStep
 from evolalg.utils.population_save import PopulationSave
-from evolalg.utils.stable_generation import StableGeneration
-from FramsticksLib import FramsticksLib
 
 
 
-EVAL_LIFESPAN_BEHAVIOR = False  # if False, standard evaluation criteria can be used as fitness as defined by the -opt parameter. If True, it is assumed that the expdef provides custom dictionary fields in evaluation and they need to be handled specifically in python source code below (this could be parametrized in command-line too, but the syntax would be complex)
+EVAL_LIFESPAN_BEHAVIOR = False  # if False, standard evaluation criteria can be used as fitness as defined by the -opt parameter. If True, it is assumed that the expdef provides custom dictionary fields in evaluation, and they need to be handled specifically in python source code below (this could be parametrized in command-line too, but the syntax would be complex).
 
 
@@ -60,5 +57,5 @@
 
 def print_population_count(pop):
-    print("Current:", len(pop))
+    print("Current popsize:", len(pop))
     return pop  # Each step must return a population
 
@@ -85,8 +82,8 @@
                     fields_defaults={"velocity": None, "data->recording": None})  # custom definitions and handling
         if EVAL_LIFESPAN_BEHAVIOR else
-        FitnessStep(frams_lib, fields={parsed_args.opt: "fitness", }, fields_defaults={})
+        FitnessStep(frams_lib, fields={parsed_args.opt: "fitness", }, fields_defaults={parsed_args.opt: None})
         ]
         +
-        ([FieldRemove("recording", None)] if EVAL_LIFESPAN_BEHAVIOR else [])
+        ([FieldRemove("recording", None)] if EVAL_LIFESPAN_BEHAVIOR else [FieldRemove("fitness", None)])
         +
         [print_population_count]  # Stages can also be any Callable