Index: cpp/frams/config/f0-SDK.def
===================================================================
--- cpp/frams/config/f0-SDK.def	(revision 1135)
+++ cpp/frams/config/f0-SDK.def	(revision 1142)
@@ -28,7 +28,7 @@
 PROP(i,1,0,`info',s,,,,info)
 PROP(Vstyle,2,0,vis_style,s,0,0,part,vis_style)
-XPROP(vr,2,0,red component,f,0.0,1.0,1.0,vcolor.x)
-XPROP(vg,2,1024,green component,f,0.0,1.0,1.0,vcolor.y)
-XPROP(vb,2,1024,blue component,f,0.0,1.0,1.0,vcolor.z)
+XPROP(vr,2,0,red component,f,0.0,1.0,0.5,vcolor.x)
+XPROP(vg,2,1024,green component,f,0.0,1.0,0.5,vcolor.y)
+XPROP(vb,2,1024,blue component,f,0.0,1.0,0.5,vcolor.z)
 ENDCLASS
 
@@ -67,7 +67,7 @@
 PROP(i,2,0,`info',s,,,,info)
 PROP(Vstyle,3,0,vis_style,s,0,0,joint,vis_style)
-XPROP(vr,3,0,red component,f,0.0,1.0,1.0,vcolor.x)
-XPROP(vg,3,1024,green component,f,0.0,1.0,1.0,vcolor.y)
-XPROP(vb,3,1024,blue component,f,0.0,1.0,1.0,vcolor.z)
+XPROP(vr,3,0,red component,f,0.0,1.0,0.5,vcolor.x)
+XPROP(vg,3,1024,green component,f,0.0,1.0,0.5,vcolor.y)
+XPROP(vb,3,1024,blue component,f,0.0,1.0,0.5,vcolor.z)
 ENDCLASS
 
@@ -95,7 +95,7 @@
 PROP(i,2,0,`info',s,,,,info)
 PROP(Vstyle,3,0,vis_style,s,0,0,joint,vis_style)
-XPROP(vr,3,0,red component,f,0.0,1.0,1.0,vcolor.x)
-XPROP(vg,3,1024,green component,f,0.0,1.0,1.0,vcolor.y)
-XPROP(vb,3,1024,blue component,f,0.0,1.0,1.0,vcolor.z)
+XPROP(vr,3,0,red component,f,0.0,1.0,0.5,vcolor.x)
+XPROP(vg,3,1024,green component,f,0.0,1.0,0.5,vcolor.y)
+XPROP(vb,3,1024,blue component,f,0.0,1.0,0.5,vcolor.z)
 ENDCLASS
 
Index: cpp/frams/config/f0.def
===================================================================
--- cpp/frams/config/f0.def	(revision 1135)
+++ cpp/frams/config/f0.def	(revision 1142)
@@ -28,7 +28,7 @@
 PROP(i,1,0,`info',s,,,,info)
 PROP(Vstyle,2,0,vis_style,s,0,0,part,vis_style)
-XPROP(vr,2,0,red component,f,0.0,1.0,1.0,vcolor.x)
-XPROP(vg,2,1024,green component,f,0.0,1.0,1.0,vcolor.y)
-XPROP(vb,2,1024,blue component,f,0.0,1.0,1.0,vcolor.z)
+XPROP(vr,2,0,red component,f,0.0,1.0,0.5,vcolor.x)
+XPROP(vg,2,1024,green component,f,0.0,1.0,0.5,vcolor.y)
+XPROP(vb,2,1024,blue component,f,0.0,1.0,0.5,vcolor.z)
 ENDCLASS
 
@@ -67,7 +67,7 @@
 PROP(i,2,0,`info',s,,,,info)
 PROP(Vstyle,3,0,vis_style,s,0,0,joint,vis_style)
-XPROP(vr,3,0,red component,f,0.0,1.0,1.0,vcolor.x)
-XPROP(vg,3,1024,green component,f,0.0,1.0,1.0,vcolor.y)
-XPROP(vb,3,1024,blue component,f,0.0,1.0,1.0,vcolor.z)
+XPROP(vr,3,0,red component,f,0.0,1.0,0.5,vcolor.x)
+XPROP(vg,3,1024,green component,f,0.0,1.0,0.5,vcolor.y)
+XPROP(vb,3,1024,blue component,f,0.0,1.0,0.5,vcolor.z)
 ENDCLASS
 
@@ -95,7 +95,7 @@
 PROP(i,2,0,`info',s,,,,info)
 PROP(Vstyle,3,0,vis_style,s,0,0,joint,vis_style)
-XPROP(vr,3,0,red component,f,0.0,1.0,1.0,vcolor.x)
-XPROP(vg,3,1024,green component,f,0.0,1.0,1.0,vcolor.y)
-XPROP(vb,3,1024,blue component,f,0.0,1.0,1.0,vcolor.z)
+XPROP(vr,3,0,red component,f,0.0,1.0,0.5,vcolor.x)
+XPROP(vg,3,1024,green component,f,0.0,1.0,0.5,vcolor.y)
+XPROP(vb,3,1024,blue component,f,0.0,1.0,0.5,vcolor.z)
 ENDCLASS
 
Index: cpp/frams/model/defassign-f0-SDK.h
===================================================================
--- cpp/frams/model/defassign-f0-SDK.h	(revision 1135)
+++ cpp/frams/model/defassign-f0-SDK.h	(revision 1142)
@@ -1,4 +1,4 @@
 // This file is a part of Framsticks SDK.  http://www.framsticks.com/
-// Copyright (C) 1999-2020  Maciej Komosinski and Szymon Ulatowski.
+// Copyright (C) 1999-2021  Maciej Komosinski and Szymon Ulatowski.
 // See LICENSE.txt for details.
 
@@ -20,7 +20,7 @@
 assim=0.25;
 vis_style="part";
-vcolor.x=1.0;
-vcolor.y=1.0;
-vcolor.z=1.0;
+vcolor.x=0.5;
+vcolor.y=0.5;
+vcolor.z=0.5;
 }
 
@@ -128,7 +128,7 @@
 stamina=0.25;
 vis_style="joint";
-vcolor.x=1.0;
-vcolor.y=1.0;
-vcolor.z=1.0;
+vcolor.x=0.5;
+vcolor.y=0.5;
+vcolor.z=0.5;
 }
 
Index: cpp/frams/model/f0-SDK-classes.h
===================================================================
--- cpp/frams/model/f0-SDK-classes.h	(revision 1135)
+++ cpp/frams/model/f0-SDK-classes.h	(revision 1142)
@@ -45,7 +45,7 @@
  {"i",1,0,"info","s",FIELD(info),},
  {"Vstyle",2,0,"vis_style","s 0 0 part",FIELD(vis_style),},
- {"vr",2,0,"red component","f 0.0 1.0 1.0",FIELD(vcolor.x),},
- {"vg",2,1024,"green component","f 0.0 1.0 1.0",FIELD(vcolor.y),},
- {"vb",2,1024,"blue component","f 0.0 1.0 1.0",FIELD(vcolor.z),},
+ {"vr",2,0,"red component","f 0.0 1.0 0.5",FIELD(vcolor.x),},
+ {"vg",2,1024,"green component","f 0.0 1.0 0.5",FIELD(vcolor.y),},
+ {"vb",2,1024,"blue component","f 0.0 1.0 0.5",FIELD(vcolor.z),},
  {0,0,0,}
 };
@@ -58,7 +58,7 @@
  {"ing",0,0,"ingestion","f 0.0 1.0 0.25",FIELD(ingest),},
  {"as",0,0,"assimilation","f 0.0 1.0 0.25",FIELD(assim),},
- {"vr",0,0,"red component","f 0.0 1.0 1.0",FIELD(vcolor.x),},
- {"vg",0,1024,"green component","f 0.0 1.0 1.0",FIELD(vcolor.y),},
- {"vb",0,1024,"blue component","f 0.0 1.0 1.0",FIELD(vcolor.z),},
+ {"vr",0,0,"red component","f 0.0 1.0 0.5",FIELD(vcolor.x),},
+ {"vg",0,1024,"green component","f 0.0 1.0 0.5",FIELD(vcolor.y),},
+ {"vb",0,1024,"blue component","f 0.0 1.0 0.5",FIELD(vcolor.z),},
  {0,0,0,}
 };
@@ -112,7 +112,7 @@
  {"i",2,0,"info","s",FIELD(info),},
  {"Vstyle",3,0,"vis_style","s 0 0 joint",FIELD(vis_style),},
- {"vr",3,0,"red component","f 0.0 1.0 1.0",FIELD(vcolor.x),},
- {"vg",3,1024,"green component","f 0.0 1.0 1.0",FIELD(vcolor.y),},
- {"vb",3,1024,"blue component","f 0.0 1.0 1.0",FIELD(vcolor.z),},
+ {"vr",3,0,"red component","f 0.0 1.0 0.5",FIELD(vcolor.x),},
+ {"vg",3,1024,"green component","f 0.0 1.0 0.5",FIELD(vcolor.y),},
+ {"vb",3,1024,"blue component","f 0.0 1.0 0.5",FIELD(vcolor.z),},
  {0,0,0,}
 };
@@ -122,7 +122,7 @@
  {"stif",0,0,"stiffness","f 0.0 1.0 1.0",FIELD(stif),},
  {"rotstif",0,0,"rotation stiffness","f 0.0 1.0 1.0",FIELD(rotstif),},
- {"vr",0,0,"red component","f 0.0 1.0 1.0",FIELD(vcolor.x),},
- {"vg",0,1024,"green component","f 0.0 1.0 1.0",FIELD(vcolor.y),},
- {"vb",0,1024,"blue component","f 0.0 1.0 1.0",FIELD(vcolor.z),},
+ {"vr",0,0,"red component","f 0.0 1.0 0.5",FIELD(vcolor.x),},
+ {"vg",0,1024,"green component","f 0.0 1.0 0.5",FIELD(vcolor.y),},
+ {"vb",0,1024,"blue component","f 0.0 1.0 0.5",FIELD(vcolor.z),},
  {0,0,0,}
 };
@@ -155,7 +155,7 @@
  {"i",2,0,"info","s",FIELD(info),},
  {"Vstyle",3,0,"vis_style","s 0 0 joint",FIELD(vis_style),},
- {"vr",3,0,"red component","f 0.0 1.0 1.0",FIELD(vcolor.x),},
- {"vg",3,1024,"green component","f 0.0 1.0 1.0",FIELD(vcolor.y),},
- {"vb",3,1024,"blue component","f 0.0 1.0 1.0",FIELD(vcolor.z),},
+ {"vr",3,0,"red component","f 0.0 1.0 0.5",FIELD(vcolor.x),},
+ {"vg",3,1024,"green component","f 0.0 1.0 0.5",FIELD(vcolor.y),},
+ {"vb",3,1024,"blue component","f 0.0 1.0 0.5",FIELD(vcolor.z),},
  {0,0,0,}
 };
@@ -165,7 +165,7 @@
  {"stif",0,0,"stiffness","f 0.0 1.0 1.0",FIELD(stif),},
  {"rotstif",0,0,"rotation stiffness","f 0.0 1.0 1.0",FIELD(rotstif),},
- {"vr",0,0,"red component","f 0.0 1.0 1.0",FIELD(vcolor.x),},
- {"vg",0,1024,"green component","f 0.0 1.0 1.0",FIELD(vcolor.y),},
- {"vb",0,1024,"blue component","f 0.0 1.0 1.0",FIELD(vcolor.z),},
+ {"vr",0,0,"red component","f 0.0 1.0 0.5",FIELD(vcolor.x),},
+ {"vg",0,1024,"green component","f 0.0 1.0 0.5",FIELD(vcolor.y),},
+ {"vb",0,1024,"blue component","f 0.0 1.0 0.5",FIELD(vcolor.z),},
  {0,0,0,}
 };